require 'installer/action'
require 'installer/errors'

class Installer::Planner::Step::VerifyMCO < Installer::Planner::Step
  def initialize(infra, data={}, pre=nil, post=nil)
    super

  end

  def perform_step(&execute)
    host = @infra.find_hosts_with_roles([:master]).first
    mcotest = Installer::Action::Execute.new(:host => host, :sudo => true, :cmd => "su peadmin -c '/opt/puppet/bin/mco find'")
    yield mcotest

    if mcotest.success?
      stdout = mcotest.results[host.hostname][:stdout]
      found = []
      @infra.hosts.each do |hostname, host|
        if Regexp.new(Regexp.escape(hostname)).match stdout
          found << hostname
        end
      end

      if found.empty?
        warning(host.hostname, "MCollective ran successfully but did not find any of the Puppet Enterprise hosts.")
      end
    else
      warning(host.hostname, "MCollective discovery failed.")
    end
  end

  def name
    :verify_mcollective
  end

  def description
    "Verify that MCollective is functioning."
  end
end
